load("@ytt:data", "data")
load("@ytt:regexp", "regexp")
load("@ytt:assert", "assert")
load("/values.star", "dependency_updates")


scopes={
    "custom":[],
    "all":[
        "base-jammy-stack.buildpacks.tanzu.vmware.com",
        "base-jammy-builder.buildpacks.tanzu.vmware.com",
        "full-jammy-stack.buildpacks.tanzu.vmware.com",
        "full-jammy-builder.buildpacks.tanzu.vmware.com",
        "tiny-jammy-stack.buildpacks.tanzu.vmware.com",
        "tiny-jammy-builder.buildpacks.tanzu.vmware.com",
        "standard-ubi-8-stack.buildpacks.tanzu.vmware.com",
        "standard-ubi-8-builder.buildpacks.tanzu.vmware.com",
        "static-jammy-stack.buildpacks.tanzu.vmware.com",
        "static-jammy-builder.buildpacks.tanzu.vmware.com",
        "java.buildpacks.tanzu.vmware.com",
        "dotnet-core.buildpacks.tanzu.vmware.com",
        "go.buildpacks.tanzu.vmware.com",
        "java-native-image.buildpacks.tanzu.vmware.com",
        "nodejs.buildpacks.tanzu.vmware.com",
        "php.buildpacks.tanzu.vmware.com",
        "procfile.buildpacks.tanzu.vmware.com",
        "python.buildpacks.tanzu.vmware.com",
        "ruby.buildpacks.tanzu.vmware.com",
        "web-servers.buildpacks.tanzu.vmware.com"
    ],
    "stacks-only":[
        "base-jammy-stack.buildpacks.tanzu.vmware.com",
        "base-jammy-builder.buildpacks.tanzu.vmware.com",
        "full-jammy-stack.buildpacks.tanzu.vmware.com",
        "full-jammy-builder.buildpacks.tanzu.vmware.com",
        "tiny-jammy-stack.buildpacks.tanzu.vmware.com",
        "tiny-jammy-builder.buildpacks.tanzu.vmware.com",
        "standard-ubi-8-stack.buildpacks.tanzu.vmware.com",
        "standard-ubi-8-builder.buildpacks.tanzu.vmware.com",
        "static-jammy-stack.buildpacks.tanzu.vmware.com",
        "static-jammy-builder.buildpacks.tanzu.vmware.com"
    ]
}

def updates_allowed(name):
  if not dependency_updates.allow:
    return False
  end

  if dependency_updates.scope not in scopes.keys():
    assert.fail("invalid scope '{}', valid scopes are '{}'".format(dependency_updates.scope, scopes.keys()))
  end

  if name in dependency_updates.exclude_packages:
    return False
  end

  updateable_packages = scopes[dependency_updates.scope] + dependency_updates.include_packages

  return name in updateable_packages
end


def unpin_version(version):
    #! replace X.Y.Z with X.Y
    res = regexp.replace("([0-9]+\.[0-9]+)\.[0-9]+.*", version, "$1")

    #! append '.x' to X.Y, .x will allow any patch version in the X.Y major/minor
    return "{}.x".format(res)
end
